local addonName, TF = ...

local TradeFill = LibStub("AceAddon-3.0"):GetAddon(addonName)
local Loc = LibStub("AceLocale-3.0"):GetLocale(addonName)

function RemoveItem(item)
    for slot = 1, MAX_TRADABLE_ITEMS do
        if GetTradePlayerItemLink(slot) ~= nil then
            local name, _, _, _, _, _ = GetTradePlayerItemInfo(slot)
            local id, _, _, _, _, _, _ = GetItemInfoInstant(GetTradePlayerItemLink(slot))

            if name ~= nil and id == item.id then
                ClearCursor()
                ClickTradeButton(slot)
                ClearCursor()
                return
            end
        end
    end
end

function TradeFill:AutoFill(item, position)
    local linkIcon = item.link .. " |T" .. GetItemIcon(item.id) .. ":0|t"

    if next(TF.inventory) == nil then
        TradeFill:Message(Loc["MESSAGE_NO_ITEM"], linkIcon, "", false)
        return
    end

    if position == nil then
        TradeFill:Message(Loc["MESSAGE_FULL"])
        return
    else
        for i = 1, TF.inventoryIndex do
            local locked = C_Container.GetContainerItemInfo(TF.inventory[i].bag, TF.inventory[i].slot)
            local stack = TF.data.setting.full

            if TF.inventory[i].bound == true then
                TradeFill:Message(Loc["MESSAGE_SOULBOUND"], linkIcon, "", false)
                return
            end

            if stack == false then
                if TF.inventory[i].item == item.id and locked.isLocked == false then
                    ClearCursor()
                    C_Container.PickupContainerItem(TF.inventory[i].bag, TF.inventory[i].slot)
                    ClickTradeButton(position)
                    ClearCursor()
                    break
                end

                if i >= TF.inventoryIndex then
                    TradeFill:Message(Loc["MESSAGE_NO_STACK"], linkIcon, "", false)
                    return
                end
            end

            if stack == true then
                if TF.inventory[i].item == item.id and locked.isLocked == false and TF.inventory[i].count == item.stack then
                    ClearCursor()
                    C_Container.PickupContainerItem(TF.inventory[i].bag, TF.inventory[i].slot)
                    ClickTradeButton(position)
                    ClearCursor()
                    break
                end

                if i >= TF.inventoryIndex then
                    TradeFill:Message(Loc["MESSAGE_NO_FULL_STACK"], linkIcon, "", false)
                    return
                end
            end
        end
    end
end